#ifndef __BLUEGATE_A__
#define __BLUEGATE_A__

#ifdef __cplusplus
extern "C"
{
#endif

/* DLL support */
#ifndef ___EXPORT
	#define ___EXPORT
#endif

/******************************************************************************/
/*     classic BlueGate functions                                             */
/*     by prof. cho                                                           */
___EXPORT BOOL BlueGate_Open(int unit);
___EXPORT void BlueGate_Close(int unit);
___EXPORT void BlueGate_CloseAll();
___EXPORT int BlueGate_Find();

___EXPORT void BlueGate_EnableIntr(int unit,BOOL enable);
___EXPORT ULONG BlueGate_WaitForIntr(int unit,ULONG timeout_msec,ULONG *input);
___EXPORT ULONG BlueGate_ReadIo(int unit);
___EXPORT ULONG BlueGate_ReadIntrStatus(int unit);
___EXPORT void BlueGate_SetIntrMask(int unit,ULONG mask);
___EXPORT void BlueGate_ClearIntrStatus(int unit);
___EXPORT ULONG BlueGate_WriteIo(int unit,ULONG data);
___EXPORT BOOL BlueGate_CreateThread(int unit,HWND hwnd,UINT msg);
___EXPORT void BlueGate_CloseThread(int unit);

___EXPORT void BlueGate_Delay(ULONG microsec);

/******************************************************************************/
/*     extended BlueGate functions                                            */
/*     by Younjae Kim (2001/01/04)                                            */
___EXPORT int BlueGate_ReadId(int unit);
___EXPORT ULONG BlueGate_ReadIn(int unit);
___EXPORT ULONG BlueGate_ReadOut(int unit);
___EXPORT ULONG BlueGate_WriteOut(int unit,ULONG data);
___EXPORT void  BlueGate_EnableOut(int unit,BOOL enable);
___EXPORT BOOL BlueGate_ReadInBit(int unit,int bit);
___EXPORT BOOL BlueGate_WriteOutBit(int unit,int bit,BOOL status);


/******************************************************************************/
/*     Hidden BlueGate functions (don't include in public version )           */
/*     by Younjae Kim (2001/01/04)                                            */
___EXPORT ULONG BlueGate_ReadBoardId(int unit);
___EXPORT ULONG BlueGate_ReadRegister(int unit,int byteoffset);
___EXPORT void BlueGate_WriteRegister(int unit,int byteoffset,ULONG value);
___EXPORT ULONG BlueGate_ReadMem(int unit,ULONG addr);
___EXPORT void BlueGate_WriteMem(int unit,ULONG addr,ULONG data);
___EXPORT ULONG *BlueGate_GetRegisterPtr(int unit);
___EXPORT ULONG *BlueGate_GetLocal0Ptr(int unit);

#ifdef __cplusplus
}
#endif

#endif